#include <iostream>
#include <vector>
#include <algorithm>
//#include <cstlib>

using namespace std;

const int MAX_N = 1 << 19;
long long t[2 * MAX_N], arr[MAX_N];

void build(int pos, int l, int r) {
    if (l == r) {
        t[pos] = arr[l];
        return;
    }
    int m = (l + r) / 2;
    build(2 * pos, l, m);
    build(2 * pos + 1, m + 1, r);
    t[pos] = __gcd(t[2 * pos], t[2 * pos + 1]);
}

long long get(int pos, int l, int r, int a, int b) {
    if (a > r || l > b) return -1;
    if (a <= l && r <= b) return t[pos];
    int m = (l + r) / 2;
    long long x = get(2 * pos, l, m, a, b);
    long long y = get(2 * pos + 1, m + 1, r, a, b);
    if (x == -1) return y;
    if (y == -1) return x;
    return __gcd(x, y);
}

int main() {
    ios_base :: sync_with_stdio(0);
    cin.tie(0);
    long long n, k;
    cin >> n >> k;
    for (int i = 1; i <= n; i++) cin >> arr[i];
    for (int i = n + 1; i < MAX_N; i++) arr[i] = 1;
    build(1, 1, MAX_N);
    long long ans = get(1, 1, MAX_N, 1, k);
    for (int i = 2; i + k - 1 <= n; i++) {
        ans = max(ans, get(1, 1, MAX_N, i, i + k - 1));
    }
    cout << ans << endl;
    return 0;
}
