#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

ll gcd(ll a, ll b){
    if(!a) return b;
    if(!b) return a;
    return gcd(b, a % b);
}

ll INF = 1e18;

struct Tree{
    vector<ll> tree;
    vector<ll> mas;

    Tree(){}
    Tree(vector<ll> ar){
        tree.resize(4 * ar.size());
        mas = ar;
        build(0, 0, ar.size());
    }

    void build(int pos, int l, int r){
        if(r - l == 1){
            tree[pos] = mas[l];
            return;
        }
        build(2 * pos + 1, l, (l + r) / 2);
        build(2 * pos + 2, (l + r) / 2, r);
        tree[pos] = gcd(tree[2 * pos + 1], tree[2 * pos + 2]);
    }

    ll get_gc(int pos, int l, int r, int vl, int vr){
        if(vl >= r || l >= vr){
            return 0;
        }
        if(vr >= r && l >= vl){
            return tree[pos];
        }
        //cout << pos << " " <<  l << " " << r << endl;
        ll a1 = get_gc(2 * pos + 1, l, (l + r) / 2, vl, vr);
        ll a2 = get_gc(2 * pos + 2, (l + r) / 2, r, vl, vr);
        if(!a1) return a2;
        if(!a2) return a1;
        return gcd(a1, a2);
    }

};



int main(){
    cin.tie(NULL);
    cout.tie(NULL);
    int n, k;
    cin >> n >> k;
    vector<ll> a(n);
    for(int i = 0; i < n; i++) cin >> a[i];
    Tree tree = Tree(a);
    ll maxi = 0;
    for(int i = 0; i <= n - k; i++){
        maxi = max(maxi, tree.get_gc(0, 0, n, i, i + k));
    }
    cout << maxi << endl;
    return 0;
}
