﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApplication2
{
    class Program
    {
        public static int n = 13;
        public static char[,] result = new char[0,0];

        static void Main(string[] args)
        {
            int n = Int32.Parse(Console.ReadLine());
            int d = Int32.Parse(Console.ReadLine());
            int k = Int32.Parse(Console.ReadLine());

            Method(n, d, k);

            while (true) { }
        }

        public static void Method(int n, int d, int k)
        {
            bool[,] grid = new bool[0,0];

            MapInfo map = GetNewMapInfo(n, d, k, ref grid);
            print(map.Height + " " + map.Width);

            grid = new bool[map.Width, map.Height];
            
            for (int x = 0; x < map.Width; x++)
            {
                for (int y = 0; y < map.Height; y++)
                {
                    print(grid[x, y] ? "*" : ".", false);
                }

                print("");
            }
        }

        public class MapInfo
        {
            public int Width = 0;
            public int Height = 0;

            public MapInfo(int Width = 0, int Height = 0)
            {
                this.Width = Width;
                this.Height = Height;
            }
        }

        public static MapInfo GetNewMapInfo(int n, int d, int k, ref bool[,] grid, Direction startDirection = Direction.Right)
        {
            int Width = 0;
            int Height = 0;

            int stepHigh = d;

            List<Direction> pathDirections = new List<Direction>();

            Direction current = startDirection;

            int alNumber = 1;

            for (int i = 0; i < n; i++)
            {
                switch (alNumber)
                {
                    case 1:
                        {
                            for (int b = 0; b < stepHigh; b++)
                            {
                                pathDirections.Add(current);
                            }
                            i += stepHigh;
                        }
                        break;
                    case 2:
                        {
                            switch (current)
                            {
                                case Direction.Up:
                                    current = Direction.Left;
                                    break;
                                case Direction.Down:
                                    current = Direction.Right;
                                    break;
                                case Direction.Right:
                                    current = Direction.Up;
                                    break;
                                case Direction.Left:
                                    current = Direction.Down;
                                    break;
                            }

                            for (int b = 0; b < stepHigh; b++)
                            {
                                pathDirections.Add(current);
                            }
                            i += stepHigh ;

                        }
                        break;

                    case 3:
                        {
                            switch (current)
                            {
                                case Direction.Up:
                                    current = Direction.Left;
                                    break;
                                case Direction.Down:
                                    current = Direction.Right;
                                    break;
                                case Direction.Right:
                                    current = Direction.Up;
                                    break;
                                case Direction.Left:
                                    current = Direction.Down;
                                    break;
                            }

                            stepHigh *= k;
                        }
                        break;
                }

                if (alNumber == 3) alNumber = 1;
                else alNumber++;

                //print(string.Format("{0} - {1} - {2}", i, current, stepHigh));
            }

            print("");

            int recordWidth = 0;
            int recordHeight = 0;

            for (int i = 0; i < pathDirections.Count; i++)
            {
                if (pathDirections[i] == Direction.Right || pathDirections[i] == Direction.Left)
                {
                    int WidthCounter = 0;

                    try
                    {
                        while (pathDirections[i + WidthCounter] == Direction.Left || pathDirections[i + WidthCounter] == Direction.Right)
                        {
                            WidthCounter++;
                        }

                        if (WidthCounter > recordWidth) recordWidth = WidthCounter + 1;
                    }
                    catch (Exception)
                    {
                        if (pathDirections.Count - 1 == i + recordHeight) WidthCounter++;

                        if (WidthCounter > recordHeight) recordHeight = WidthCounter;
                    } 
                }

                if (pathDirections[i] == Direction.Down || pathDirections[i] == Direction.Up)
                {
                    int HeightCounter = 0;

                    try
                    {
                        while (pathDirections[i + HeightCounter] == Direction.Up || pathDirections[i + HeightCounter] == Direction.Down)
                        {
                            HeightCounter++;
                        }

                        if (HeightCounter > recordHeight) recordHeight = HeightCounter + 1;
                    }
                    catch (Exception) 
                    {
                        if (pathDirections.Count - 1 == i + recordHeight) HeightCounter++;

                        if (HeightCounter > recordHeight) recordHeight = HeightCounter;
                    } 
                }
            }

            bool[,] newGrid = new bool[Width, Height];

            int x = (int)(recordWidth / 2);
            int y = (int)(recordHeight / 2);

            for (int i = 0; i < pathDirections.Count; i++)
            {
                try
                {
                    switch (pathDirections[i])
                    {
                        case Direction.Up:
                            y++;
                            newGrid[x, y] = true;
                            break;
                        case Direction.Down:
                            y--;
                            newGrid[x, y] = true;
                            break;
                        case Direction.Right:
                            x++;
                            newGrid[x, y] = true;
                            break;
                        case Direction.Left:
                            x--;
                            newGrid[x, y] = true;
                            break;
                    }
                }
                catch (Exception) { }
            }

            Width = recordWidth;
            Height = recordHeight;
            grid = newGrid;

            return new MapInfo(Width,Height);
        }

        public static void print<T>(T content, bool onNewLine = true)
        {
            if (onNewLine) Console.WriteLine(content);
            else Console.Write(content);
        }

        public enum Direction
        {
            Up,
            Down,
            Right,
            Left
        }
    }
}
