#include <iostream>
#include <vector>

using namespace std;

struct int2
{
  int X, Y;

  int2( int x, int y) : X(x), Y(y)
  {
  }
};

int2 GoDir( int2 Pos, int Dir )
{
  if (Dir % 2 == 0)
    Pos.Y += Dir - 1;
  else
    Pos.X += -(Dir - 2);
  return Pos;
}

int main( void )
{
  int n = 0, d = 0, k = 0;

  cin >> n >> d >> k;
  std::vector<int2> Pixels;
  Pixels.reserve(100000);

  int2 Cur(0, 0);
  int Dir = 1;    // 0 - down, 1 - right, 2 - up, 3 - left
  Pixels.push_back(Cur);

  int minX = 0, minY = 0, maxX = 0, maxY = 0;

  bool IsEnd = 0;
  while (n > 0)
  {
    for (int i = 0; i < d; i++)
    {
      Cur = GoDir(Cur, Dir);
      if (minX > Cur.X)
        minX = Cur.X;
      if (maxX < Cur.X)
        maxX = Cur.X;
      if (minY > Cur.Y)
        minY = Cur.Y;
      if (maxY < Cur.Y)
        maxY = Cur.Y;
      Pixels.push_back(Cur);
      n--;
      if (n <= 0)
      {
        IsEnd = 1;
        break;
      }
    }
    if (IsEnd)
      break;
    Dir = (Dir + 1) % 4;
    for (int i = 0; i < d; i++)
    {
      Cur = GoDir(Cur, Dir);
      if (minX > Cur.X)
        minX = Cur.X;
      if (maxX < Cur.X)
        maxX = Cur.X;
      if (minY > Cur.Y)
        minY = Cur.Y;
      if (maxY < Cur.Y)
        maxY = Cur.Y;
      Pixels.push_back(Cur);
      n--;
      if (n <= 0)
      {
        IsEnd = 1;
        break;
      }
    }
    if (IsEnd)
      break;
    Dir = (Dir + 1) % 4;
    d *= k;
  }
  int w = maxX - minX + 1, h = maxY - minY + 1;
  char *data = new char[w * h];
  memset(data, '.', w * h);
  for (auto &i : Pixels)
    data[(i.Y - minY) * w + i.X - minX] = '*';
  cout << h << " " << w << endl;
  for (int y = h - 1; y >= 0; y--)
  {
    for (int x = 0; x < w; x++)
      cout << data[y * w + x];
    cout << endl;
  }
  return 0;
}