#include <iostream>
#include <algorithm>
#include <vector>


#define llint long long int
using namespace std;

vector <llint> tree;

llint gcd (llint a, llint b)
{
      llint t = a;
      a = max(b, a);
      b = min(b, t);
      return b == 0 ? a : gcd(b, a % b);
}

llint getV(const llint& position, llint left_border, llint right_border, llint answer = 1)
{ 
     if (left_border == right_border)
       return answer;
     llint middle = (left_border + right_border) / 2;
     if (position <= middle)
       return getV(position, left_border, middle, answer*2);
     else
       return getV(position, middle + 1, right_border, 2*answer + 1);
}


void buildTree(llint V, llint left_border, llint right_border, const vector<llint>& base)
{
  if (right_border == left_border)
  {
    tree[V] = base[left_border];
    return;
  };

  llint left_end = (left_border + right_border) / 2;
  llint right_begin = left_end + 1;

  buildTree(2*V, left_border, left_end, base);
  buildTree(2*V + 1, right_begin, right_border, base);

  tree[V] = gcd(tree[2*V], tree[2*V + 1]);
/*  cout << "V: " << V << endl;
  cout << "From " << left_border << " to " << right_border << endl;
  cout << "Gcd is " << tree[V] << endl;*/
}

void updateV(llint V, llint new_mean)
{
    tree[V] = new_mean;
    if (V % 2 == 0)
         tree[V/2] = gcd(new_mean, tree[V + 1]);
    else
         tree[V/2] = gcd(new_mean, tree[V - 1]);
    if (V > 1)
      updateV(V/2, tree[V/2]);
}




int main()
{
          llint N, k;
          cin >> N >> k;
          vector<llint> base(N);
          for (llint i = 0; i < N; i++)
          {
            cin >> base[i];
          };
          tree.resize(4*k, 0);
          buildTree(1, 0, k - 1, base);

          llint answer = tree[1];
          for (llint i = 0; i < N - k; i++)
          {
               updateV(getV(i % k, 0, k - 1), base[i + k]);
               answer = max(answer, tree[1]);
          };
          cout << answer << endl;
          system("pause");
}
